# Class MeshCollection

java.lang.Object
org.jmol.shape.Shape
org.jmol.shape.MeshCollection

Direct Known Subclasses:
  `CGO, Draw, Isosurface`

public abstract class MeshCollection extends Shape

## Field Summary

Fields
Modifier and Type
Field
Description
`protected BS`
`bsDisplay`
`short`
`colix`
`protected int`
`color`
`protected int[]`
`connections`
`Mesh`
`currentMesh`
`protected float`
`displayWithinDistance2`
`protected Lst<P3>`
`displayWithinPoints`
`boolean`
`explicitID`
`protected Map<String,Mesh>`
`htObjects`
`protected boolean`
`isDisplayWithinNot`
`boolean`
`isFixed`
`protected JvxlData`
`jvxlData`
`protected Mesh`
`linkedMesh`
`int`
`meshCount`
`Mesh[]`
`meshes`
`protected int`
`modelIndex`
`int`
`nUnnamed`
`protected Mesh`
`pickedMesh`
`protected int`
`pickedModel`
`protected T3`
`pickedPt`
`protected int`
`pickedVertex`
`static final String`
`PREVIOUS_MESH_ID`
`protected String`
`previousMeshID`
`String[]`
`title`

### Fields inherited from class Shape

`bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

## Constructor Summary

Constructors
Constructor
Description
`MeshCollection()`

## Method Summary

Modifier and Type
Method
Description
`void`
`allocMesh(String thisID, Mesh m)`
`protected void`
`checkExplicit(String id)`
`protected void`
`clean()`
`void`
`deleteMeshI(int i)`
`protected void`
`deleteMeshKey(String key)`
`int`
`getIndexFromName(String id)`
`Mesh`
`getMesh(String thisID)`
`protected Lst<Mesh>`
`getMeshList(String key, boolean justOne)`
Get matching list of meshes, order reversed
`protected Map<String,Object>`
`getPickedPoint(T3 v, int modelIndex)`
`protected boolean`
`getPropDataMC(String property, Object[] data)`
`protected Object`
`getPropMC(String property, int index)`
`protected Object`
`getValues(Mesh mesh)`
`protected Object`
`getVertices(Mesh mesh)`
`void`
`initShape()`
`void`
`merge(MeshCollection mc)`
called by ParallelProcessor at completion
`protected void`
`resetObjects()`
`protected void`
`setMeshColor()`
`void`
`setModelVisibilityFlags(BS bsModels)`
`protected void`
`setPropMC(String propertyName, Object value, BS bs)`
`protected void`
`setStatusPicked(int flag, T3 v, Map<String,Object> map)`
`protected String[]`
`setTitle(Object value)`
`protected void`
`setTokenProperty(int tokProp, boolean bProp, boolean testD)`

### Methods inherited from class Shape

`appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, findNearestAtomIndex, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getProperty, getPropertyData, getPropShape, getShapeDetail, getShapeState, getSize, getSizeG, getTranslucentLabel, initializeShape, initModelSet, replaceGroup, setAtomClickability, setModelSet, setProperties, setProperty, setPropS, setShapeSizeRD, setSize, setSizeRD, wasClicked`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### jvxlData

protected JvxlData jvxlData

### meshCount

public int meshCount

### meshes

public Mesh[] meshes

### currentMesh

public Mesh currentMesh

### isFixed

public boolean isFixed

### nUnnamed

public int nUnnamed

### colix

public short colix

### explicitID

public boolean explicitID

### previousMeshID

protected String previousMeshID

### linkedMesh

protected Mesh linkedMesh

### modelIndex

protected int modelIndex

### displayWithinDistance2

protected float displayWithinDistance2

### isDisplayWithinNot

protected boolean isDisplayWithinNot

### displayWithinPoints

protected Lst<P3> displayWithinPoints

### bsDisplay

protected BS bsDisplay

### title

public String[] title

### pickedMesh

protected Mesh pickedMesh

### pickedModel

protected int pickedModel

### pickedVertex

protected int pickedVertex

### pickedPt

protected T3 pickedPt

### connections

protected int[] connections

### htObjects

protected Map<String,Mesh> htObjects

### color

protected int color

### PREVIOUS_MESH_ID

public static final String PREVIOUS_MESH_ID

See Also:
  - Constant Field Values

## Constructor Details

### MeshCollection

public MeshCollection()

## Method Details

### allocMesh

public void allocMesh(String thisID, Mesh m)

### merge

public void merge(MeshCollection mc)
called by ParallelProcessor at completion

Parameters:
  `mc` -

### initShape

public void initShape()

Specified by:
  `initShape` in class `Shape`

### setMeshColor

protected void setMeshColor()

### setPropMC

protected void setPropMC(String propertyName, Object value, BS bs)

### setTitle

protected String[] setTitle(Object value)

### checkExplicit

protected void checkExplicit(String id)

### setTokenProperty

protected void setTokenProperty(int tokProp, boolean bProp, boolean testD)

### getPropDataMC

protected boolean getPropDataMC(String property, Object[] data)

### getMeshList

protected Lst<Mesh> getMeshList(String key, boolean justOne)
Get matching list of meshes, order reversed

Parameters:
  `key` -
  `justOne` -
Returns:
  list in reverse order, highest index first

### getPropMC

protected Object getPropMC(String property, int index)

### getValues

protected Object getValues(Mesh mesh)

### getVertices

protected Object getVertices(Mesh mesh)

### clean

protected void clean()

### deleteMeshKey

protected void deleteMeshKey(String key)

### deleteMeshI

public void deleteMeshI(int i)

### resetObjects

protected void resetObjects()

### getMesh

public Mesh getMesh(String thisID)

### getIndexFromName

public int getIndexFromName(String id)

Overrides:
  `getIndexFromName` in class `Shape`
Parameters:
  `id` -
Returns:
  index

### setModelVisibilityFlags

public void setModelVisibilityFlags(BS bsModels)

Overrides:
  `setModelVisibilityFlags` in class `Shape`
Parameters:
  `bsModels` -

### setStatusPicked

protected void setStatusPicked(int flag, T3 v, Map<String,Object> map)

### getPickedPoint

protected Map<String,Object> getPickedPoint(T3 v, int modelIndex)